## ros-kinetic-mitre-fast-layered-map 0.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(mitre_fast_layered_map)

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
    roscpp
    tf2
    tf2_ros
    tf2_msgs
    tf2_sensor_msgs
    tf2_geometry_msgs
    tf2_eigen
    tf2_kdl
    grid_map_core
    grid_map_ros
    grid_map_msgs
    grid_map_loader
    grid_map_rviz_plugin
    grid_map_visualization
    sensor_msgs
    geometry_msgs
    filters
    pcl_ros
    pcl_conversions
    cv_bridge
    rostest
)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED)
# It found eigen on its own for awhile and then stopped for some reason
set(CMAKE_PREFIX_PATH "/usr/lib/cmake/eigen3/Eigen3Config.cmake")
find_package(Eigen3 REQUIRED)

#set(catkin_LIBRARIES ${catkin_LIBRARIES} -pg)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES mitre_fast_layered_map
#  CATKIN_DEPENDS other_catkin_pkg
#  DEPENDS system_lib
)

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(
    include
    ${catkin_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIR}
)

## Declare a C++ library
add_library(filter_plugins
   src/filters/outlier_removal.cpp
   src/filters/ray_trace_2d.cpp
   src/filters/inflation.cpp
   src/filters/bayes_update.cpp
   src/filters/threshold_filter.cpp
)

add_library(${PROJECT_NAME}
  src/sensor_map.cpp
  src/test_map.cpp
  src/static_map.cpp
)

target_link_libraries(${PROJECT_NAME} filter_plugins ${catkin_LIBRARIES})

### Sensor Map Node
add_executable(sensor_map_node src/sensor_map_node.cpp)

### Static Map node
add_executable(static_map_node src/static_map_node)

### Specify libraries to link a library or executable target against
target_link_libraries(sensor_map_node
  ${PROJECT_NAME}
)

target_link_libraries(static_map_node
  ${PROJECT_NAME}
)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables for installation
install(TARGETS 
  sensor_map_node 
  static_map_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark libraries for installation
install(TARGETS ${PROJECT_NAME} filter_plugins
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(PROGRAMS src/utils/publish_marker.py
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.hpp"
  PATTERN ".svn" EXCLUDE
)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY launch config
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

install(FILES filter_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
if(CATKIN_ENABLE_TESTING)

  find_package(rostest REQUIRED)

  include_directories(
    test/include
  )

  add_rostest_gtest(test_filter_outlier_removal 
    test/launch/outlier_removal.launch 
    test/test_filter_outlier_removal.cpp
    test/test_mitre_fast_layered_map.cpp)
  target_link_libraries(test_filter_outlier_removal ${catkin_LIBRARIES})

  add_rostest_gtest(test_filter_ray_trace
    test/launch/ray_trace.launch
    test/test_filter_ray_trace.cpp
    test/test_mitre_fast_layered_map.cpp)
  target_link_libraries(test_filter_ray_trace ${catkin_LIBRARIES})

  add_rostest_gtest(test_filter_inflation
    test/launch/inflation.launch
    test/test_filter_inflation.cpp
    test/test_mitre_fast_layered_map.cpp)
  target_link_libraries(test_filter_inflation ${catkin_LIBRARIES})

  add_rostest_gtest(test_filter_bayes_update
    test/launch/bayes_update.launch
    test/test_filter_bayes_update.cpp
    test/test_mitre_fast_layered_map.cpp)
  target_link_libraries(test_filter_bayes_update ${catkin_LIBRARIES})

  add_rostest_gtest(test_filter_threshold
    test/launch/threshold.launch
    test/test_filter_threshold.cpp
    test/test_mitre_fast_layered_map.cpp)
  target_link_libraries(test_filter_threshold ${catkin_LIBRARIES})

  add_rostest_gtest(test_map 
    test/launch/map.launch 
    test/test_map.cpp 
    test/test_mitre_fast_layered_map.cpp
    test/init_vars.cpp)
  target_link_libraries(test_map ${PROJECT_NAME} filter_plugins ${catkin_LIBRARIES})

  #catkin_add_gtest(${PROJECT_NAME}-test 
  #  test/test_dart_gridmap.cpp
  #  test/test_filter_inflation.cpp
  #  test/test_filter_outlier_removal.cpp
  #  test/test_filter_ray_trace.cpp
  #  test/test_local_map.cpp
  #  test/test_map_controller.cpp
  #)

  #if(TARGET ${PROJECT_NAME}-test)
  # target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME} ${catkin_LIBRARIES})
  #endif()
endif()

#target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})

#target_link_libraries(${PROJECT_NAME}-test filter_plugins)

#if(TARGET ${PROJECT_NAME}-test)
#  target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME} filter_plugins)
#endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-kinetic-mitre-fast-layered-map (0.1.4-2xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- tbostic <tbostic@mitre.org>  Mon, 08 Mar 2021 15:44:26 -0000

=== debian/control ===
Source: ros-kinetic-mitre-fast-layered-map
Section: misc
Priority: optional
Maintainer: tbostic <tbostic@mitre.org>
Build-Depends: debhelper (>= 9.0.0), libpcl1.7, ros-kinetic-catkin, ros-kinetic-cv-bridge, ros-kinetic-filters, ros-kinetic-geometry-msgs, ros-kinetic-grid-map-core, ros-kinetic-grid-map-loader, ros-kinetic-grid-map-msgs, ros-kinetic-grid-map-ros, ros-kinetic-grid-map-rviz-plugin, ros-kinetic-grid-map-visualization, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-pluginlib, ros-kinetic-roscpp, ros-kinetic-rosunit, ros-kinetic-sensor-msgs, ros-kinetic-tf2, ros-kinetic-tf2-eigen, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-kdl, ros-kinetic-tf2-ros, ros-kinetic-tf2-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-mitre-fast-layered-map
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl1.7, ros-kinetic-cv-bridge, ros-kinetic-filters, ros-kinetic-geometry-msgs, ros-kinetic-grid-map-core, ros-kinetic-grid-map-loader, ros-kinetic-grid-map-msgs, ros-kinetic-grid-map-ros, ros-kinetic-grid-map-rviz-plugin, ros-kinetic-grid-map-visualization, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-pluginlib, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-tf2, ros-kinetic-tf2-eigen, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-kdl, ros-kinetic-tf2-ros, ros-kinetic-tf2-sensor-msgs
Description: The mitre_fast_layered_map package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-mitre-fast-layered-map//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
